diff -ruN dput-0.9.2.6.6.old/FAQ dput-0.9.2.6.6/FAQ
--- dput-0.9.2.6.6.old/FAQ	2002-10-11 21:47:34.000000000 +0200
+++ dput-0.9.2.6.6/FAQ	2002-10-11 21:52:09.000000000 +0200
@@ -15,7 +15,7 @@
    suffix, I had to decide between "rc" or ".cf". I decided to use
    ".cf" as suffix, because it's an obvious abbreviation for
    configuration and also I noticed that postfix uses it as extension.
-   Since this extension is now used for quite some time, I'm not
+   Since this extension has now been used for quite some time, I'm not
    planning to change it. Any change would need a lot of work or
    introduce problems for the users.
 
@@ -35,24 +35,24 @@
    Now, seriously, it's a matter of preferences. If you use dupload
    and like it's behaviour, then continue to use it. But in every
    case, I would suggest that you try dput, since it will check the
-   GnuPG signature and the Checksums before uploading and offer to
-   run dinstall in dry-run mode after the upload. It also offers the
-   usage of other upload methods via modules.
+   GnuPG signature and the checksums before uploading and offer to run
+   dinstall in dry-run mode after the upload. It also offers the usage
+   of other upload methods via modules.
 
-5. Where are modules and what are they exactly use for?
+5. Where are modules and what are they exactly used for?
   
    dput uses modules for the different upload methods that it offers.
-   All upload methods are implemented via seperate modules that can
-   will be loaded at runtime. That way we can easily extend the
-   number of upload methods that dput offers. So if you write or
-   already wrote a new upload method, then please inform the author
-   of dput, so that it maybe can be added to dput in the future.
+   All upload methods are implemented via seperate modules that will
+   be loaded at runtime. That way we can easily extend the number of
+   upload methods that dput offers. So if you write or already wrote a
+   new upload method, then please inform the author of dput, so that
+   it maybe can be added to dput in the future.
 
 6. Can I just copy /etc/dput.cf into my homedir as .dput.cf?
 
-   No, this shouldn't be done, because .dput.cf is a configuration file
-   for the user. It should only contain configuration variables which 
-   have a value different from the default and which the user need to
-   define. This will reduce the risk of breaking dput, if either some
-   default value in /etc/dput.cf will be changed or a new configuration
-   variable will be added.
+   No, this shouldn't be done, because .dput.cf is a configuration
+   file for the user. It should only contain configuration variables
+   which have a value different from the default and which the user
+   needs to define. This will reduce the risk of breaking dput, if
+   either some default value in /etc/dput.cf is changed or a new
+   configuration variable is added.
diff -ruN dput-0.9.2.6.6.old/README dput-0.9.2.6.6/README
--- dput-0.9.2.6.6.old/README	2002-10-11 21:47:34.000000000 +0200
+++ dput-0.9.2.6.6/README	2002-10-11 21:48:21.000000000 +0200
@@ -11,7 +11,7 @@
 * Test of the GnuPG signature on the dsc-File
 * Verification of the check sums in the dsc-File.
 * Support for md5 and sha check sums.
-* Check for unnessary .tar.gz's or missing .tar.gz's
+* Check for unnecessary .tar.gz's or missing .tar.gz's
 * Running lintian before putting the package into the archive
 * Running dinstall after the package is in the archive and making sure that
   the package will be put on the correct server.
diff -ruN dput-0.9.2.6.6.old/bash_completion dput-0.9.2.6.6/bash_completion
--- dput-0.9.2.6.6.old/bash_completion	1970-01-01 01:00:00.000000000 +0100
+++ dput-0.9.2.6.6/bash_completion	2002-10-14 09:12:32.000000000 +0200
@@ -0,0 +1,48 @@
+#-*- mode: shell-script;-*-
+
+# Debian GNU/Linux dput(1) completion
+# Copyright 2002 Roland Mas <lolando@debian.org>
+
+have dput &&
+_dput()
+{
+    local cur prev options paroptions special i delayed_options hosts
+    
+    COMPREPLY=()
+    cur=${COMP_WORDS[COMP_CWORD]}
+    prev=${COMP_WORDS[COMP_CWORD-1]}
+    options='-c --config -d --debug -D --dinstall -f --force -h --help \
+             -H --host-list -l --lintian -o --check-only -p --print \
+             -P --passive -s --simulate -u --unchecked -d --delayed \
+             -v --version -V --check-version'
+
+    hosts=$(
+	{
+	    grep "\[.*\]" $HOME/.dput.cf 2> /dev/null | tr -d [] || /bin/true
+	    grep "\[.*\]" /etc/dput.cf 2> /dev/null | tr -d [] || /bin/true
+	} | grep -v '^DEFAULT$' | sort -u)
+
+    paroptions="$options $hosts"
+
+    case $prev in
+	--delayed|-e)
+	    delayed_options='1 2 3 4 5 6 7 8 9'
+	    COMPREPLY=( $( compgen -W "$delayed_options" | grep ^$cur ) )
+	    ;;
+	--config|-c)
+	    COMPREPLY=( $( compgen -o filenames -G "$cur*" ) )
+	    ;;
+	*)
+	    COMPREPLY=( $(
+		    compgen -G "${cur}*.changes"
+		    compgen -G "${cur}*.asc"
+		    compgen -G "${cur}*.sig"
+		    compgen -W "$paroptions" | grep "^$cur"
+		) )
+	    ;;
+    esac
+
+    return 0
+
+}
+[ "$have" ] && complete -F _dput -o filenames dput
diff -ruN dput-0.9.2.6.6.old/debian/changelog dput-0.9.2.6.6/debian/changelog
--- dput-0.9.2.6.6.old/debian/changelog	2002-10-11 21:47:34.000000000 +0200
+++ dput-0.9.2.6.6/debian/changelog	2002-10-14 09:15:39.000000000 +0200
@@ -1,3 +1,18 @@
+dput (0.9.2.6.6+lolando) unstable; urgency=low
+
+  * Added a (very simple) module called local.py (derived from scp.py by
+    Roland Mas <lolando@debian.org>), to install to local incoming dirs.
+    This can be useful to users of mini-dinstall.
+  * Added a French translation to the Debconf template.
+  * Fixed a Lintian error.
+  * A few grammar fixes in the FAQ and README files.
+  * Added a /etc/bash_completion.d/dput file, to make dput easier to use
+    to <TAB>-addicteb people like me.
+  * NMWNU (Not the maintainer, will not upload).  Just sending the patch
+    along.
+
+ -- Roland Mas <lolando@debian.org>  Mon, 14 Oct 2002 09:15:28 +0200
+
 dput (0.9.2.6.6) unstable; urgency=low
 
   * Another NMU.
diff -ruN dput-0.9.2.6.6.old/debian/control dput-0.9.2.6.6/debian/control
--- dput-0.9.2.6.6.old/debian/control	2002-10-11 21:47:34.000000000 +0200
+++ dput-0.9.2.6.6/debian/control	2002-10-11 22:28:35.000000000 +0200
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Christian Kurz <shorty@debian.org>
-Build-Depends: debconf-utils (>= 1.1.1)
+Build-Depends-Indep: debconf-utils (>= 1.1.1)
 Standards-Version: 3.5.6
 
 Package: dput
@@ -19,4 +19,5 @@
  This is very useful to see if the the upload will pass dinstall sanity
  checks in the next run.
  .
- It's intended for Debian maintainers only.
+ It's intended mainly for Debian maintainers only, although it can
+ also be useful for people maintaining local apt repositories.
diff -ruN dput-0.9.2.6.6.old/debian/rules dput-0.9.2.6.6/debian/rules
--- dput-0.9.2.6.6.old/debian/rules	2002-10-11 21:47:34.000000000 +0200
+++ dput-0.9.2.6.6/debian/rules	2002-10-14 09:17:35.000000000 +0200
@@ -23,6 +23,7 @@
 	install -d --mode=0755 "debian/tmp/DEBIAN"
 	install -d --mode=0755 "debian/tmp/usr/bin"
 	install -d --mode=0755 "debian/tmp/etc"
+	install -d --mode=0755 "debian/tmp/etc/bash_completion.d"
 	install -d --mode=0755 "debian/tmp/usr/share/doc/$(PACKAGE)"
 	install -d --mode=0755 "debian/tmp/usr/share/man/man1"
 	install -d --mode=0755 "debian/tmp/usr/share/man/man5"
@@ -33,6 +34,7 @@
 	install --mode=0644 dput.cf.5 "debian/tmp/usr/share/man/man5"
 	install --mode=0644 ftp.py "debian/tmp/usr/share/dput"
 	install --mode=0644 scp.py "debian/tmp/usr/share/dput"
+	install --mode=0644 local.py "debian/tmp/usr/share/dput"
 	install --mode=0644 rsync.py "debian/tmp/usr/share/dput"
 	#install --mode=0644 ConfigParser2.py "debian/tmp/usr/share/dput"
 	#install --mode=0644 spawnvef.py "debian/tmp/usr/share/dput"
@@ -42,6 +44,7 @@
 	#install --mode=0644 Todo "debian/tmp/usr/share/doc/$(PACKAGE)"
 	install --mode=0644 Thanks "debian/tmp/usr/share/doc/$(PACKAGE)"
 	install --mode=0644 debian/changelog "debian/tmp/usr/share/doc/$(PACKAGE)"
+	install --mode=0644 bash_completion "debian/tmp/etc/bash_completion.d/$(PACKAGE)"
 	# Merge templates, and install the merged one where it belongs
 	debconf-mergetemplate --drop-old-templates debian/templates.* debian/templates > debian/tmp/DEBIAN/templates
 	chmod 0644 debian/tmp/DEBIAN/templates
diff -ruN dput-0.9.2.6.6.old/debian/templates.fr dput-0.9.2.6.6/debian/templates.fr
--- dput-0.9.2.6.6.old/debian/templates.fr	1970-01-01 01:00:00.000000000 +0100
+++ dput-0.9.2.6.6/debian/templates.fr	2002-10-11 22:32:53.000000000 +0200
@@ -0,0 +1,16 @@
+Template: dput/config-file-format
+Type: note
+Description: Change config file after installation
+ The dput package changed the format of it's config file, because
+ of some major rewrites in the parser for it. Therefore, if you were
+ using a personal ~/.dput.cf, you have to update it to the new style
+ before you can use dput again. See the global file at /etc/dput.cf
+ and the man pages for more info.
+Description-fr: Changer le fichier de configuration après installation
+ Le paquet dput a changé de format pour ses fichiers de configuration,
+ en raison d'importantes modifications dans l'interpréteur desdits
+ fichiers.  En conséquence, si vous utilisiez un fichier ~/.dput.cf,
+ vous devrez le mettre à jour pour qu'il suive le nouveau format avant
+ de pouvoir recommencer à utiliser dput.  Pour plus d'information,
+ référez-vous au fichier de configuration global (/etc/dput.cf) et aux
+ pages de manuel.
diff -ruN dput-0.9.2.6.6.old/dput dput-0.9.2.6.6/dput
--- dput-0.9.2.6.6.old/dput	2002-10-11 21:47:34.000000000 +0200
+++ dput-0.9.2.6.6/dput	2002-10-11 23:10:46.000000000 +0200
@@ -755,6 +755,9 @@
                 if (config.get('DEFAULT', 'method') == 'ftp' and \
                   config.get(host, 'method') == 'scp'):
                     method = config.get(host, 'method')      
+                elif (config.get('DEFAULT', 'method') == 'ftp' and \
+                  config.get(host, 'method') == 'local'):
+                    method = config.get(host, 'method')      
                 else:
                     method = config.get('DEFAULT', 'method')
             else:
@@ -813,7 +816,7 @@
                     files_to_upload, debug, scp_compress)
             else:
                 upload_methods[method](fqdn, login, incoming, \
-                    files_to_upload, debug)
+                    files_to_upload, debug, 0)
         # Or just simulate it.
         else:
             for file in files_to_upload:
diff -ruN dput-0.9.2.6.6.old/dput.cf dput-0.9.2.6.6/dput.cf
--- dput-0.9.2.6.6.old/dput.cf	2002-10-11 21:47:34.000000000 +0200
+++ dput-0.9.2.6.6/dput.cf	2002-10-11 23:11:33.000000000 +0200
@@ -67,3 +67,9 @@
 method = scp
 incoming = /org/non-us.debian.org/incoming
 allow_non-us_software = 1
+
+[local]
+fqdn = localhost
+method = local
+incoming = /var/www/debian/mini-dinstall/incoming
+allow_non-us_software = 1
diff -ruN dput-0.9.2.6.6.old/dput.cf.5 dput-0.9.2.6.6/dput.cf.5
--- dput-0.9.2.6.6.old/dput.cf.5	2002-10-11 21:47:34.000000000 +0200
+++ dput-0.9.2.6.6/dput.cf.5	2002-10-11 22:18:11.000000000 +0200
@@ -46,6 +46,11 @@
 the package will be uploaded using rsync over ssh. This is similar to scp,
 but can save some bandwidth if the destination file already exists on the
 upload server. It also needs a login on the remote machine as it uses ssh.
+.TP
+.I local
+the package will be "uploaded" locally using /usr/bin/install.  This
+transfers files to a local incoming directory, and needs appropriate
+permissions set on that directory.
 .RE
 .TP
 .B hash
diff -ruN dput-0.9.2.6.6.old/local.py dput-0.9.2.6.6/local.py
--- dput-0.9.2.6.6.old/local.py	1970-01-01 01:00:00.000000000 +0100
+++ dput-0.9.2.6.6/local.py	2002-10-11 22:25:14.000000000 +0200
@@ -0,0 +1,24 @@
+# Upload the files with /usr/bin/install in a batch.
+
+import os,sys,stat
+
+def upload(fqdn,login,incoming,files_to_upload,debug,compress):
+    # fqdn, login, compress are ignored
+    # Maybe login should be used for "install -o <login>"?
+
+    files_to_fix = []
+
+    for file in files_to_upload:
+        to_fix = os.path.basename(file)
+        file_to_fix = os.path.join(incoming, to_fix)
+        files_to_fix.append(file_to_fix)
+    
+    command = ['/usr/bin/install', '-m', '644', incoming]
+    command[3:3] = files_to_upload
+    if debug:
+        print "D: Uploading with cp to %s" % \
+            (incoming)
+        print "D: %s" % command
+    if os.spawnv(os.P_WAIT, '/usr/bin/install', command):
+        print "Error while uploading."
+        sys.exit(1)
